* ERRHSTCK.PRG - generic ErrHandler UDF to produce a printable stack history
* By M. Asherman, Copyright (c) 1999 - 2002, SpaceTime Systems
*
* 10/1/02: adapted from inline code in ERRHVFMS.PRG for use in diagnostic tracing.
*
* Returns a printable stack history listing, deepest first.

lparameters depth_arg			&& takes 1 optional argument
* depth_arg:	maximum program depth to display to.
*				If empty, display to depth just below this call.

local depth, msg, n

depth = iif(empty(m.depth_arg), ;
  max(program(-1) - 1, 0), ;
  m.depth_arg) 					&& supply a default depth, if needed
msg = ''						&& start with empty result accumulator

for n = m.depth to 1 step -1	&& loop from deepest to shallowest depth
	msg = iif(empty(m.msg), '', m.msg + chr(13)) ;
	  + 'Program(' + ltrim(str(m.n)) + '): ' + program(m.n)
endfor

return m.msg					&& return printable stack history string
